Index: wp-admin/includes/nav-menu.php
===================================================================
--- wp-admin/includes/nav-menu.php	(revision 23265)
+++ wp-admin/includes/nav-menu.php	(working copy)
@@ -382,8 +382,6 @@
  **/
 function wp_nav_menu_setup() {
 	// Register meta boxes
-	if ( wp_get_nav_menus() )
-		add_meta_box( 'nav-menu-theme-locations', __( 'Theme Locations' ), 'wp_nav_menu_locations_meta_box' , 'nav-menus', 'side', 'default' );
 	add_meta_box( 'add-custom-links', __('Custom Links'), 'wp_nav_menu_item_link_meta_box', 'nav-menus', 'side', 'default' );
 	wp_nav_menu_post_type_meta_boxes();
 	wp_nav_menu_taxonomy_meta_boxes();
@@ -471,54 +469,6 @@
 }
 
 /**
- * Displays a metabox for the nav menu theme locations.
- *
- * @since 3.0.0
- */
-function wp_nav_menu_locations_meta_box() {
-	global $nav_menu_selected_id;
-
-	if ( ! current_theme_supports( 'menus' ) ) {
-		// We must only support widgets. Leave a message and bail.
-		echo '<p class="howto">' . __('The current theme does not natively support menus, but you can use the &#8220;Custom Menu&#8221; widget to add any menus you create here to the theme&#8217;s sidebar.') . '</p>';
-		return;
-	}
-
-	$locations = get_registered_nav_menus();
-	$menus = wp_get_nav_menus();
-	$menu_locations = get_nav_menu_locations();
-	$num_locations = count( array_keys($locations) );
-
-	echo '<p class="howto">' . sprintf( _n('Your theme supports %s menu. Select which menu you would like to use.', 'Your theme supports %s menus. Select which menu appears in each location.', $num_locations ), number_format_i18n($num_locations) ) . '</p>';
-
-	foreach ( $locations as $location => $description ) {
-		?>
-		<p>
-			<label class="howto" for="locations-<?php echo $location; ?>">
-				<span><?php echo $description; ?></span>
-				<select name="menu-locations[<?php echo $location; ?>]" id="locations-<?php echo $location; ?>">
-					<option value="0"></option>
-					<?php foreach ( $menus as $menu ) : ?>
-					<option<?php selected( isset( $menu_locations[ $location ] ) && $menu_locations[ $location ] == $menu->term_id ); ?>
-						value="<?php echo $menu->term_id; ?>"><?php
-						$truncated_name = wp_html_excerpt( $menu->name, 40 );
-						echo $truncated_name == $menu->name ? $menu->name : trim( $truncated_name ) . '&hellip;';
-					?></option>
-					<?php endforeach; ?>
-				</select>
-			</label>
-		</p>
-	<?php
-	}
-	?>
-	<p class="button-controls">
-		<?php submit_button( __( 'Save' ), 'primary right', 'nav-menu-locations', false, disabled( $nav_menu_selected_id, 0, false ) ); ?>
-		<span class="spinner"></span>
-	</p>
-	<?php
-}
-
-/**
  * Displays a metabox for the custom links menu item.
  *
  * @since 3.0.0
Index: wp-admin/js/nav-menu.js
===================================================================
--- wp-admin/js/nav-menu.js	(revision 23265)
+++ wp-admin/js/nav-menu.js	(working copy)
@@ -47,7 +47,7 @@
 
 			this.initToggles();
 
-			this.initTabManager();
+			this.initSelectMenuDropdown();
 		},
 
 		jQueryExtensions : function() {
@@ -222,6 +222,19 @@
 				}
 			});
 		},
+		
+		initSelectMenuDropdown : function () {
+			var menuSelector = $('.menu-selector select');
+			
+			menuSelector.on('change', function () {
+				var url = $(this).val();
+				
+				if (url && '--' !== url) {
+					$('.menu-selector .spinner').show();
+					window.location = url;
+				}
+			});
+		},
 
 		initToggles : function() {
 			// init postboxes
@@ -461,6 +474,8 @@
 				if( '' == $t.val() )
 					$t.addClass( name ).val( $t.data(name) );
 			});
+			
+			$('.blank-slate .input-with-default-title').focus();
 		},
 
 		attachThemeLocationsListeners : function() {
@@ -688,139 +703,6 @@
 			});
 		},
 
-		initTabManager : function() {
-			var fixed = $('.nav-tabs-wrapper'),
-				fluid = fixed.children('.nav-tabs'),
-				active = fluid.children('.nav-tab-active'),
-				tabs = fluid.children('.nav-tab'),
-				tabsWidth = 0,
-				fixedRight, fixedLeft,
-				arrowLeft, arrowRight, resizeTimer, css = {},
-				marginFluid = api.isRTL ? 'margin-right' : 'margin-left',
-				marginFixed = api.isRTL ? 'margin-left' : 'margin-right',
-				msPerPx = 2;
-
-			/**
-			 * Refreshes the menu tabs.
-			 * Will show and hide arrows where necessary.
-			 * Scrolls to the active tab by default.
-			 *
-			 * @param savePosition {boolean} Optional. Prevents scrolling so
-			 * 		  that the current position is maintained. Default false.
-			 **/
-			api.refreshMenuTabs = function( savePosition ) {
-				var fixedWidth = fixed.width(),
-					margin = 0, css = {};
-				fixedLeft = fixed.offset().left;
-				fixedRight = fixedLeft + fixedWidth;
-
-				if( !savePosition )
-					active.makeTabVisible();
-
-				// Prevent space from building up next to the last tab if there's more to show
-				if( tabs.last().isTabVisible() ) {
-					margin = fixed.width() - tabsWidth;
-					margin = margin > 0 ? 0 : margin;
-					css[marginFluid] = margin + 'px';
-					fluid.animate( css, 100, "linear" );
-				}
-
-				// Show the arrows only when necessary
-				if( fixedWidth > tabsWidth )
-					arrowLeft.add( arrowRight ).hide();
-				else
-					arrowLeft.add( arrowRight ).show();
-			}
-
-			$.fn.extend({
-				makeTabVisible : function() {
-					var t = this.eq(0), left, right, css = {}, shift = 0;
-
-					if( ! t.length ) return this;
-
-					left = t.offset().left;
-					right = left + t.outerWidth();
-
-					if( right > fixedRight )
-						shift = fixedRight - right;
-					else if ( left < fixedLeft )
-						shift = fixedLeft - left;
-
-					if( ! shift ) return this;
-
-					css[marginFluid] = "+=" + api.negateIfRTL * shift + 'px';
-					fluid.animate( css, Math.abs( shift ) * msPerPx, "linear" );
-					return this;
-				},
-				isTabVisible : function() {
-					var t = this.eq(0),
-						left = t.offset().left,
-						right = left + t.outerWidth();
-					return ( right <= fixedRight && left >= fixedLeft ) ? true : false;
-				}
-			});
-
-			// Find the width of all tabs
-			tabs.each(function(){
-				tabsWidth += $(this).outerWidth(true);
-			});
-
-			// Set up fixed margin for overflow, unset padding
-			css['padding'] = 0;
-			css[marginFixed] = (-1 * tabsWidth) + 'px';
-			fluid.css( css );
-
-			// Build tab navigation
-			arrowLeft = $('<div class="nav-tabs-arrow nav-tabs-arrow-left"><a>&laquo;</a></div>');
-			arrowRight = $('<div class="nav-tabs-arrow nav-tabs-arrow-right"><a>&raquo;</a></div>');
-			// Attach to the document
-			fixed.wrap('<div class="nav-tabs-nav"/>').parent().prepend( arrowLeft ).append( arrowRight );
-
-			// Set the menu tabs
-			api.refreshMenuTabs();
-			// Make sure the tabs reset on resize
-			$(window).resize(function() {
-				if( resizeTimer ) clearTimeout(resizeTimer);
-				resizeTimer = setTimeout( api.refreshMenuTabs, 200);
-			});
-
-			// Build arrow functions
-			$.each([{
-					arrow : arrowLeft,
-					next : "next",
-					last : "first",
-					operator : "+="
-				},{
-					arrow : arrowRight,
-					next : "prev",
-					last : "last",
-					operator : "-="
-				}], function(){
-				var that = this;
-				this.arrow.mousedown(function(){
-					var marginFluidVal = Math.abs( parseInt( fluid.css(marginFluid) ) ),
-						shift = marginFluidVal,
-						css = {};
-
-					if( "-=" == that.operator )
-						shift = Math.abs( tabsWidth - fixed.width() ) - marginFluidVal;
-
-					if( ! shift ) return;
-
-					css[marginFluid] = that.operator + shift + 'px';
-					fluid.animate( css, shift * msPerPx, "linear" );
-				}).mouseup(function(){
-					var tab, next;
-					fluid.stop(true);
-					tab = tabs[that.last]();
-					while( (next = tab[that.next]()) && next.length && ! next.isTabVisible() ) {
-						tab = next;
-					}
-					tab.makeTabVisible();
-				});
-			});
-		},
-
 		eventOnClickEditLink : function(clickedEl) {
 			var settings, item,
 			matchedSection = /#(.*)$/.exec(clickedEl.href);
Index: wp-admin/nav-menus.php
===================================================================
--- wp-admin/nav-menus.php	(revision 23265)
+++ wp-admin/nav-menus.php	(working copy)
@@ -460,12 +460,42 @@
 ?>
 <div class="wrap">
 	<?php screen_icon(); ?>
-	<h2><?php esc_html_e('Menus'); ?></h2>
+	<h2><?php esc_html_e('Menus'); ?> <a href="<?php
+		echo esc_url(add_query_arg(
+			array(
+				'action' => 'edit',
+				'menu' => 0,
+			),
+			admin_url( 'nav-menus.php' )
+		));
+	?>" class="add-new-h2">Add New</a></h2>
 	<?php
 	foreach( $messages as $message ) :
 		echo $message . "\n";
 	endforeach;
 	?>
+	<?php if ( 1 < count( $nav_menus ) ) : ?>
+	<p class="menu-selector">
+		<span class="spinner"></span>
+		<select>
+			<option value="" selected="selected">Select a menu</option>
+		<?php
+		foreach( (array) $nav_menus as $_nav_menu ) : ?>
+			<option value="<?php
+				echo esc_url(add_query_arg(
+					array(
+						'action' => 'edit',
+						'menu' => $_nav_menu->term_id,
+					),
+					admin_url( 'nav-menus.php' )
+				));
+			?>">
+				<?php echo esc_html( $_nav_menu->truncated_name ); ?>
+			</option>
+		<?php endforeach; ?>
+		</select>
+	</p>
+	<?php endif; ?>
 	<div id="nav-menus-frame">
 	<div id="menu-settings-column" class="metabox-holder<?php if ( !$nav_menu_selected_id ) { echo ' metabox-holder-disabled'; } ?>">
 
@@ -494,44 +524,11 @@
 					<?php submit_button( __( 'Select' ), 'secondary', 'select_menu', false ); ?>
 				</form>
 			</div>
-			<div class="nav-tabs-wrapper">
-			<div class="nav-tabs">
-				<?php
-				foreach( (array) $nav_menus as $_nav_menu ) :
-					if ( $nav_menu_selected_id == $_nav_menu->term_id ) : ?><span class="nav-tab nav-tab-active">
-							<?php echo esc_html( $_nav_menu->truncated_name ); ?>
-						</span><?php else : ?><a href="<?php
-							echo esc_url(add_query_arg(
-								array(
-									'action' => 'edit',
-									'menu' => $_nav_menu->term_id,
-								),
-								admin_url( 'nav-menus.php' )
-							));
-						?>" class="nav-tab hide-if-no-js">
-							<?php echo esc_html( $_nav_menu->truncated_name ); ?>
-						</a><?php endif;
-				endforeach;
-				if ( 0 == $nav_menu_selected_id ) : ?><span class="nav-tab menu-add-new nav-tab-active">
-					<?php printf( '<abbr title="%s">+</abbr>', esc_html__( 'Add menu' ) ); ?>
-				</span><?php else : ?><a href="<?php
-					echo esc_url(add_query_arg(
-						array(
-							'action' => 'edit',
-							'menu' => 0,
-						),
-						admin_url( 'nav-menus.php' )
-					));
-				?>" class="nav-tab menu-add-new">
-					<?php printf( '<abbr title="%s">+</abbr>', esc_html__( 'Add menu' ) ); ?>
-				</a><?php endif; ?>
-			</div>
-			</div>
 			<div class="menu-edit">
 				<form id="update-nav-menu" action="<?php echo admin_url( 'nav-menus.php' ); ?>" method="post" enctype="multipart/form-data">
 					<div id="nav-menu-header">
 						<div id="submitpost" class="submitbox">
-							<div class="major-publishing-actions">
+							<div class="major-publishing-actions  <?php if ( isset( $_GET['menu'] ) && 0 == $_GET['menu'] ) echo 'blank-slate'; ?>">
 								<label class="menu-name-label howto open-label" for="menu-name">
 									<span><?php _e('Menu Name'); ?></span>
 									<input name="menu-name" id="menu-name" type="text" class="menu-name regular-text menu-item-textbox input-with-default-title" title="<?php esc_attr_e('Enter menu name here'); ?>" value="<?php echo esc_attr( $nav_menu_selected_title ); ?>" />
@@ -602,6 +599,50 @@
 		</div><!-- /#menu-management -->
 	</div><!-- /#menu-management-liquid -->
 	</div><!-- /#nav-menus-frame -->
+	<div class="menu-locations">
+		<h3>Select menus for your theme</h3>
+		<?php
+		if ( ! current_theme_supports( 'menus' ) ) {
+			// We must only support widgets. Leave a message and bail.
+			echo '<p class="howto">' . __('The current theme does not natively support menus, but you can use the &#8220;Custom Menu&#8221; widget to add any menus you create here to the theme&#8217;s sidebar.') . '</p>';
+		}
+
+		if ( wp_get_nav_menus() ) : 
+	
+			$locations = get_registered_nav_menus();
+			$menus = wp_get_nav_menus();
+			$menu_locations = get_nav_menu_locations();
+			$num_locations = count( array_keys($locations) );
+
+			echo '<p>' . sprintf( _n('Your theme supports %s menu. Select which menu you would like to use.', 'Your theme supports %s menus. Select which menu appears in each location.', $num_locations ), number_format_i18n($num_locations) ) . '</p>';
+			?>
+			<form enctype="multipart/form-data" method="post" class="nav-menu-meta" action="<?php echo admin_url( 'nav-menus.php' ); ?>">
+				<input type="hidden" value="<?php echo esc_attr( $nav_menu_selected_id ); ?>" id="nav-menu-meta-object-id" name="menu">
+				<input type="hidden" value="add-menu-item" name="action">
+				<?php wp_nonce_field( 'add-menu_item', 'menu-settings-column-nonce' ); ?>
+			<?php
+
+			foreach ( $locations as $location => $description ) {
+				?>
+				<p>
+					<label class="desc" for="locations-<?php echo $location; ?>"><?php echo $description; ?></label>
+					<select name="menu-locations[<?php echo $location; ?>]" id="locations-<?php echo $location; ?>">
+						<option value="0"></option>
+						<?php foreach ( $menus as $menu ) : ?>
+						<option<?php selected( isset( $menu_locations[ $location ] ) && $menu_locations[ $location ] == $menu->term_id ); ?>
+							value="<?php echo $menu->term_id; ?>"><?php
+							$truncated_name = wp_html_excerpt( $menu->name, 40 );
+							echo $truncated_name == $menu->name ? $menu->name : trim( $truncated_name ) . '&hellip;';
+						?></option>
+						<?php endforeach; ?>
+					</select>
+				</p>
+			<?php } ?>
+			<?php submit_button( __( 'Save' ), 'primary', 'nav-menu-locations', false ); ?>
+			<span class="spinner"></span>
+		<?php endif; ?>
+		</form>
+	</div>
 </div><!-- /.wrap-->
 
 <?php include( './admin-footer.php' ); ?>
Index: wp-admin/css/wp-admin.css
===================================================================
--- wp-admin/css/wp-admin.css	(revision 23265)
+++ wp-admin/css/wp-admin.css	(working copy)
@@ -6760,7 +6760,7 @@
 	margin-left: -300px;
 	clear: both;
 	float: left;
-	padding-top: 24px;
+	padding-top: 0;
 }
 
 .no-js #wpbody-content #menu-settings-column {
@@ -6785,10 +6785,39 @@
 	position: relative;
 }
 
+.menu-selector {
+	float: right;
+}
+
+.menu-selector .spinner {
+	float: left; 
+}
+
+.blank-slate br {
+	display: none;
+}
+
+.blank-slate .menu-name {
+	height: 2em;
+}
+
+.menu-locations {
+	border-top: 1px solid #ddd;
+}
+
+.menu-locations .desc {
+	width: 200px;
+}
+
+.menu-locations .spinner {
+	float: none;
+}
+
 /* Menu Container */
 #menu-management-liquid {
 	float: left;
 	min-width: 100%;
+	margin-top: 3px;
 }
 
 #menu-management {
@@ -6835,55 +6864,6 @@
 	font-weight:bold;
 }
 
-/* Menu Tabs */
-
-#menu-management .nav-tabs-nav {
-	margin: 0 20px;
-}
-
-#menu-management .nav-tabs-arrow {
-	width: 10px;
-	padding: 0 5px 4px;
-	cursor: pointer;
-	position: absolute;
-	top: 0;
-	line-height: 22px;
-	font-size: 18px;
-	text-shadow: 0 1px 0 #fff;
-}
-
-#menu-management .nav-tabs-arrow-left {
-	left: 0;
-}
-
-#menu-management .nav-tabs-arrow-right {
-	right: 0;
-	text-align: right;
-}
-
-#menu-management .nav-tabs-wrapper {
-	width: 100%;
-	height: 28px;
-	margin-bottom: -1px;
-	overflow: hidden;
-}
-
-#menu-management .nav-tabs {
-	padding-left: 20px;
-	padding-right: 10px;
-}
-
-.js #menu-management .nav-tabs {
-	float: left;
-	margin-left: 0px;
-	margin-right: -400px;
-}
-
-#menu-management .nav-tab {
-	margin-bottom: 0;
-	font-size: 14px;
-}
-
 #select-nav-menu-container {
 	text-align: right;
 	padding: 0 10px 3px 10px;
@@ -7326,6 +7306,11 @@
 	margin: 5px 0 1px;
 }
 
+.nav-menus-php .blank-slate .publishing-action {
+	float: left;
+	margin: 1px 0 0;
+}
+
 .nav-menus-php .major-publishing-actions .delete-action {
 	vertical-align: middle;
 	text-align: left;