Index: wp-admin/includes/nav-menu.php
===================================================================
--- wp-admin/includes/nav-menu.php	(revision 23293)
+++ wp-admin/includes/nav-menu.php	(working copy)
@@ -80,12 +80,16 @@
 		}
 
 		$title = empty( $item->label ) ? $title : $item->label;
+		
+		$submenu_text = '';
+		if (0 == $depth)
+			$submenu_text = 'style="display: none;"';
 
 		?>
 		<li id="menu-item-<?php echo $item_id; ?>" class="<?php echo implode(' ', $classes ); ?>">
 			<dl class="menu-item-bar">
 				<dt class="menu-item-handle">
-					<span class="item-title"><?php echo esc_html( $title ); ?></span>
+					<span class="item-title"><?php echo esc_html( $title ); ?> <span class="is-submenu" <?php echo $submenu_text; ?>><?php _e( 'sub item' ); ?></span></span>
 					<span class="item-controls">
 						<span class="item-type"><?php echo esc_html( $item->type_label ); ?></span>
 						<span class="item-order hide-if-js">
@@ -382,11 +386,16 @@
  **/
 function wp_nav_menu_setup() {
 	// Register meta boxes
-	if ( wp_get_nav_menus() )
-		add_meta_box( 'nav-menu-theme-locations', __( 'Theme Locations' ), 'wp_nav_menu_locations_meta_box' , 'nav-menus', 'side', 'default' );
-	add_meta_box( 'add-custom-links', __('Custom Links'), 'wp_nav_menu_item_link_meta_box', 'nav-menus', 'side', 'default' );
-	wp_nav_menu_post_type_meta_boxes();
-	wp_nav_menu_taxonomy_meta_boxes();
+	if ( wp_get_nav_menus() && ! isset( $_POST['menu-name'] ) && ! isset( $_GET['action'] ) || isset( $_GET['_wpnonce'] ) )
+		add_meta_box( 'nav-menu-theme-locations', __( 'Menus within your theme' ), 'wp_nav_menu_locations_meta_box' , 'nav-menus', 'side', 'default' );
+	
+	$nav_menus = wp_get_nav_menus( array('orderby' => 'name') );
+	
+	if ( empty( $nav_menus ) || isset( $_POST['menu-name'] ) || isset( $_GET['action'] ) && ! isset( $_GET['_wpnonce'] ) ) {
+		add_meta_box( 'add-custom-links', __('Custom Links'), 'wp_nav_menu_item_link_meta_box', 'nav-menus', 'side', 'default' );
+		wp_nav_menu_post_type_meta_boxes();
+		wp_nav_menu_taxonomy_meta_boxes();
+	}
 
 	// Register advanced menu items (columns)
 	add_filter( 'manage_nav-menus_columns', 'wp_nav_menu_manage_columns');
@@ -489,7 +498,7 @@
 	$menu_locations = get_nav_menu_locations();
 	$num_locations = count( array_keys($locations) );
 
-	echo '<p class="howto">' . sprintf( _n('Your theme supports %s menu. Select which menu you would like to use.', 'Your theme supports %s menus. Select which menu appears in each location.', $num_locations ), number_format_i18n($num_locations) ) . '</p>';
+	echo '<p class="howto">' . _n('Select a menu to use within your theme.', 'Select the menus you will use in your theme.', $num_locations ) . '</p>';
 
 	foreach ( $locations as $location => $description ) {
 		?>
@@ -512,7 +521,7 @@
 	}
 	?>
 	<p class="button-controls">
-		<?php submit_button( __( 'Save' ), 'primary right', 'nav-menu-locations', false, disabled( $nav_menu_selected_id, 0, false ) ); ?>
+		<?php submit_button( __( 'Save' ), 'primary right', 'nav-menu-locations', false ); ?>
 		<span class="spinner"></span>
 	</p>
 	<?php
@@ -1086,7 +1095,7 @@
 		$menu_items = wp_get_nav_menu_items( $menu->term_id, array('post_status' => 'any') );
 		$result = '<div id="menu-instructions" class="post-body-plain';
 		$result .= ( ! empty($menu_items) ) ? ' menu-instructions-inactive">' : '">';
-		$result .= '<p>' . __('Select menu items (pages, categories, links) from the boxes at left to begin building your custom menu.') . '</p>';
+		$result .= '<p>' . __('Next, add menu items (i.e. pages, links, categories) from the column on the left.') . '</p>';
 		$result .= '</div>';
 
 		if( empty($menu_items) )
@@ -1158,5 +1167,4 @@
 	foreach( (array) $menu_items_to_delete as $menu_item_id )
 		wp_delete_post( $menu_item_id, true );
 }
-
-add_action('admin_head-nav-menus.php', '_wp_delete_orphaned_draft_menu_items');
+add_action('admin_head-nav-menus.php', '_wp_delete_orphaned_draft_menu_items');
\ No newline at end of file
Index: wp-admin/js/nav-menu.js
===================================================================
--- wp-admin/js/nav-menu.js	(revision 23293)
+++ wp-admin/js/nav-menu.js	(working copy)
@@ -46,8 +46,8 @@
 				this.initSortables();
 
 			this.initToggles();
-
-			this.initTabManager();
+			
+			this.messageFadeIn();
 		},
 
 		jQueryExtensions : function() {
@@ -222,6 +222,13 @@
 				}
 			});
 		},
+		
+		messageFadeIn : function() {
+			var messages = $('#message');
+			
+			// Visual change when users save menus multiple times in a row
+			messages.slideDown('slow');
+		},
 
 		initToggles : function() {
 			// init postboxes
@@ -245,6 +252,9 @@
 				menuEdge = api.menuList.offset().left,
 				body = $('body'), maxChildDepth,
 				menuMaxDepth = initialMenuMaxDepth();
+				
+			if( 0 != $('#menu-to-edit li').length )
+				$('.drag-instructions').show();
 
 			// Use the right edge if RTL.
 			menuEdge += api.isRTL ? api.menuList.width() : 0;
@@ -307,6 +317,13 @@
 
 					// Return child elements to the list
 					children = transport.children().insertAfter(ui.item);
+					
+					// Add "sub menu" description
+					var subMenuTitle = ui.item.find('.item-title .is-submenu');
+					if (0 < currentDepth)
+						subMenuTitle.show();
+					else
+						subMenuTitle.hide();
 
 					// Update depth classes
 					if( depthChange != 0 ) {
@@ -327,9 +344,6 @@
 						ui.item[0].style.left = 'auto';
 						ui.item[0].style.right = 0;
 					}
-
-					// The width of the tab bar might have changed. Just in case.
-					api.refreshMenuTabs( true );
 				},
 				change: function(e, ui) {
 					// Make sure the placeholder is inside the menu.
@@ -461,6 +475,8 @@
 				if( '' == $t.val() )
 					$t.addClass( name ).val( $t.data(name) );
 			});
+			
+			$('.blank-slate .input-with-default-title').focus();
 		},
 
 		attachThemeLocationsListeners : function() {
@@ -572,6 +588,9 @@
 			$.post( ajaxurl, params, function(menuMarkup) {
 				var ins = $('#menu-instructions');
 				processMethod(menuMarkup, params);
+				// Make it stand out a bit more visually, by adding a fadeIn
+				$('li.pending').hide().fadeIn('slow');
+				$('.drag-instructions').show();
 				if( ! ins.hasClass('menu-instructions-inactive') && ins.siblings().length )
 					ins.addClass('menu-instructions-inactive');
 				callback();
@@ -604,7 +623,7 @@
 				};
 			} else {
 				// Make the post boxes read-only, as they can't be used yet
-				$('#menu-settings-column').find('input,select').prop('disabled', true).end().find('a').attr('href', '#').unbind('click');
+				$('#menu-settings-column').find('input,select').end().find('a').attr('href', '#').unbind('click');
 			}
 		},
 
@@ -688,139 +707,6 @@
 			});
 		},
 
-		initTabManager : function() {
-			var fixed = $('.nav-tabs-wrapper'),
-				fluid = fixed.children('.nav-tabs'),
-				active = fluid.children('.nav-tab-active'),
-				tabs = fluid.children('.nav-tab'),
-				tabsWidth = 0,
-				fixedRight, fixedLeft,
-				arrowLeft, arrowRight, resizeTimer, css = {},
-				marginFluid = api.isRTL ? 'margin-right' : 'margin-left',
-				marginFixed = api.isRTL ? 'margin-left' : 'margin-right',
-				msPerPx = 2;
-
-			/**
-			 * Refreshes the menu tabs.
-			 * Will show and hide arrows where necessary.
-			 * Scrolls to the active tab by default.
-			 *
-			 * @param savePosition {boolean} Optional. Prevents scrolling so
-			 * 		  that the current position is maintained. Default false.
-			 **/
-			api.refreshMenuTabs = function( savePosition ) {
-				var fixedWidth = fixed.width(),
-					margin = 0, css = {};
-				fixedLeft = fixed.offset().left;
-				fixedRight = fixedLeft + fixedWidth;
-
-				if( !savePosition )
-					active.makeTabVisible();
-
-				// Prevent space from building up next to the last tab if there's more to show
-				if( tabs.last().isTabVisible() ) {
-					margin = fixed.width() - tabsWidth;
-					margin = margin > 0 ? 0 : margin;
-					css[marginFluid] = margin + 'px';
-					fluid.animate( css, 100, "linear" );
-				}
-
-				// Show the arrows only when necessary
-				if( fixedWidth > tabsWidth )
-					arrowLeft.add( arrowRight ).hide();
-				else
-					arrowLeft.add( arrowRight ).show();
-			}
-
-			$.fn.extend({
-				makeTabVisible : function() {
-					var t = this.eq(0), left, right, css = {}, shift = 0;
-
-					if( ! t.length ) return this;
-
-					left = t.offset().left;
-					right = left + t.outerWidth();
-
-					if( right > fixedRight )
-						shift = fixedRight - right;
-					else if ( left < fixedLeft )
-						shift = fixedLeft - left;
-
-					if( ! shift ) return this;
-
-					css[marginFluid] = "+=" + api.negateIfRTL * shift + 'px';
-					fluid.animate( css, Math.abs( shift ) * msPerPx, "linear" );
-					return this;
-				},
-				isTabVisible : function() {
-					var t = this.eq(0),
-						left = t.offset().left,
-						right = left + t.outerWidth();
-					return ( right <= fixedRight && left >= fixedLeft ) ? true : false;
-				}
-			});
-
-			// Find the width of all tabs
-			tabs.each(function(){
-				tabsWidth += $(this).outerWidth(true);
-			});
-
-			// Set up fixed margin for overflow, unset padding
-			css['padding'] = 0;
-			css[marginFixed] = (-1 * tabsWidth) + 'px';
-			fluid.css( css );
-
-			// Build tab navigation
-			arrowLeft = $('<div class="nav-tabs-arrow nav-tabs-arrow-left"><a>&laquo;</a></div>');
-			arrowRight = $('<div class="nav-tabs-arrow nav-tabs-arrow-right"><a>&raquo;</a></div>');
-			// Attach to the document
-			fixed.wrap('<div class="nav-tabs-nav"/>').parent().prepend( arrowLeft ).append( arrowRight );
-
-			// Set the menu tabs
-			api.refreshMenuTabs();
-			// Make sure the tabs reset on resize
-			$(window).resize(function() {
-				if( resizeTimer ) clearTimeout(resizeTimer);
-				resizeTimer = setTimeout( api.refreshMenuTabs, 200);
-			});
-
-			// Build arrow functions
-			$.each([{
-					arrow : arrowLeft,
-					next : "next",
-					last : "first",
-					operator : "+="
-				},{
-					arrow : arrowRight,
-					next : "prev",
-					last : "last",
-					operator : "-="
-				}], function(){
-				var that = this;
-				this.arrow.mousedown(function(){
-					var marginFluidVal = Math.abs( parseInt( fluid.css(marginFluid) ) ),
-						shift = marginFluidVal,
-						css = {};
-
-					if( "-=" == that.operator )
-						shift = Math.abs( tabsWidth - fixed.width() ) - marginFluidVal;
-
-					if( ! shift ) return;
-
-					css[marginFluid] = that.operator + shift + 'px';
-					fluid.animate( css, shift * msPerPx, "linear" );
-				}).mouseup(function(){
-					var tab, next;
-					fluid.stop(true);
-					tab = tabs[that.last]();
-					while( (next = tab[that.next]()) && next.length && ! next.isTabVisible() ) {
-						tab = next;
-					}
-					tab.makeTabVisible();
-				});
-			});
-		},
-
 		eventOnClickEditLink : function(clickedEl) {
 			var settings, item,
 			matchedSection = /#(.*)$/.exec(clickedEl.href);
@@ -945,8 +831,10 @@
 					var ins = $('#menu-instructions');
 					el.remove();
 					children.shiftDepthClass(-1).updateParentMenuItemDBId();
-					if( ! ins.siblings().length )
+					if( 0 == $('#menu-to-edit li').length ) {
+						$('.drag-instructions').hide();
 						ins.removeClass('menu-instructions-inactive');
+					}
 				});
 		},
 
Index: wp-admin/nav-menus.php
===================================================================
--- wp-admin/nav-menus.php	(revision 23293)
+++ wp-admin/nav-menus.php	(working copy)
@@ -460,14 +460,17 @@
 ?>
 <div class="wrap">
 	<?php screen_icon(); ?>
-	<h2><?php esc_html_e('Menus'); ?></h2>
+	<h2 class="nav-tab-wrapper">
+		<a href="<?php echo admin_url( 'nav-menus.php' ); ?>" class="nav-tab<?php if ( ! isset( $_POST['menu-name'] ) && ! isset( $_GET['action'] ) || isset( $_GET['_wpnonce'] ) ) echo ' nav-tab-active'; ?>"><?php esc_html_e('Manage Menus'); ?></a>
+		<a href="<?php echo esc_url( add_query_arg( array( 'action' => 'edit', 'menu' => 0, ), admin_url( 'nav-menus.php' ) ) ); ?>" class="nav-tab<?php if ( isset( $_GET['menu'] ) && '0' == $_GET['menu'] ) echo ' nav-tab-active'; ?>"><?php esc_html_e('Add Menu'); ?></a>
+	</h2>
 	<?php
 	foreach( $messages as $message ) :
 		echo $message . "\n";
 	endforeach;
 	?>
 	<div id="nav-menus-frame">
-	<div id="menu-settings-column" class="metabox-holder<?php if ( !$nav_menu_selected_id ) { echo ' metabox-holder-disabled'; } ?>">
+	<div id="menu-settings-column" class="metabox-holder<?php if ( isset( $_GET['menu'] ) && '0' == $_GET['menu'] || empty( $nav_menus ) ) { echo ' metabox-holder-disabled'; } ?>">
 
 		<form id="nav-menu-meta" action="<?php echo admin_url( 'nav-menus.php' ); ?>" class="nav-menu-meta" method="post" enctype="multipart/form-data">
 			<input type="hidden" name="menu" id="nav-menu-meta-object-id" value="<?php echo esc_attr( $nav_menu_selected_id ); ?>" />
@@ -479,59 +482,42 @@
 	</div><!-- /#menu-settings-column -->
 	<div id="menu-management-liquid">
 		<div id="menu-management">
-			<div id="select-nav-menu-container" class="hide-if-js">
-				<form id="select-nav-menu" action="">
-					<strong><label for="select-nav-menu"><?php esc_html_e( 'Select Menu:' ); ?></label></strong>
-					<select class="select-nav-menu" name="menu">
+			<?php if ( ! isset( $_POST['menu-name'] ) && ! empty( $nav_menus ) && ! isset( $_GET['action'] ) || isset( $_GET['_wpnonce'] ) ) : ?>
+			<div id="select-nav-menu-container">
+				
+				<!-- Temporary (throw away) code just to test users on this concept -->
+				<table cellspacing="0" class="wp-list-table widefat fixed tags">
+					<thead>
+						<tr>
+							<th style="" class="manage-column column-name desc" id="name" scope="col"><span>Menu Name</span></th>
+						</tr>
+					</thead>
+					<tfoot>
+						<tr>
+							<th style="" class="manage-column column-name desc" scope="col"><span>Menu Name</span></th>
+						</tr>
+					</tfoot>
+					<tbody data-wp-lists="list:tag" id="the-list">
 						<?php foreach( (array) $nav_menus as $_nav_menu ) : ?>
-							<option value="<?php echo esc_attr($_nav_menu->term_id) ?>" <?php selected($nav_menu_selected_id, $_nav_menu->term_id); ?>>
-								<?php echo esc_html( $_nav_menu->truncated_name ); ?>
-							</option>
+						<tr>
+							<td style="text-align: left;">
+								<strong><a title="<?php echo esc_html( $_nav_menu->truncated_name ); ?>" href="<?php echo admin_url('nav-menus.php?action=edit&menu=' . esc_attr($_nav_menu->term_id)); ?>" class="row-title"><?php echo esc_html( $_nav_menu->truncated_name ); ?></a></strong><br />
+								<div class="row-actions">
+									<span class="edit"><a href="<?php echo admin_url('nav-menus.php?action=edit&menu=' . esc_attr($_nav_menu->term_id)); ?>">Edit</a> | </span>
+									<span class="trash"><a class="submitdelete" title="Delete this menu" href="<?php echo esc_url( wp_nonce_url( admin_url('nav-menus.php?action=delete&amp;menu=' . esc_attr($_nav_menu->term_id)), 'delete-nav_menu-' . esc_attr($_nav_menu->term_id) ) ); ?>">Delete</a></span>
+								</div>
+							</td>
+						</tr>
 						<?php endforeach; ?>
-						<option value="0"><?php esc_html_e('Add New Menu'); ?></option>
-					</select>
-					<input type="hidden" name="action" value="edit" />
-					<?php submit_button( __( 'Select' ), 'secondary', 'select_menu', false ); ?>
-				</form>
+					</tbody>
+				</table>
 			</div>
-			<div class="nav-tabs-wrapper">
-			<div class="nav-tabs">
-				<?php
-				foreach( (array) $nav_menus as $_nav_menu ) :
-					if ( $nav_menu_selected_id == $_nav_menu->term_id ) : ?><span class="nav-tab nav-tab-active">
-							<?php echo esc_html( $_nav_menu->truncated_name ); ?>
-						</span><?php else : ?><a href="<?php
-							echo esc_url(add_query_arg(
-								array(
-									'action' => 'edit',
-									'menu' => $_nav_menu->term_id,
-								),
-								admin_url( 'nav-menus.php' )
-							));
-						?>" class="nav-tab hide-if-no-js">
-							<?php echo esc_html( $_nav_menu->truncated_name ); ?>
-						</a><?php endif;
-				endforeach;
-				if ( 0 == $nav_menu_selected_id ) : ?><span class="nav-tab menu-add-new nav-tab-active">
-					<?php printf( '<abbr title="%s">+</abbr>', esc_html__( 'Add menu' ) ); ?>
-				</span><?php else : ?><a href="<?php
-					echo esc_url(add_query_arg(
-						array(
-							'action' => 'edit',
-							'menu' => 0,
-						),
-						admin_url( 'nav-menus.php' )
-					));
-				?>" class="nav-tab menu-add-new">
-					<?php printf( '<abbr title="%s">+</abbr>', esc_html__( 'Add menu' ) ); ?>
-				</a><?php endif; ?>
-			</div>
-			</div>
+			<?php else : ?>
 			<div class="menu-edit">
 				<form id="update-nav-menu" action="<?php echo admin_url( 'nav-menus.php' ); ?>" method="post" enctype="multipart/form-data">
 					<div id="nav-menu-header">
 						<div id="submitpost" class="submitbox">
-							<div class="major-publishing-actions">
+							<div class="major-publishing-actions <?php if ( isset( $_GET['menu'] ) && 0 == $_GET['menu'] || empty( $nav_menus ) ) echo 'blank-slate'; ?>">
 								<label class="menu-name-label howto open-label" for="menu-name">
 									<span><?php _e('Menu Name'); ?></span>
 									<input name="menu-name" id="menu-name" type="text" class="menu-name regular-text menu-item-textbox input-with-default-title" title="<?php esc_attr_e('Enter menu name here'); ?>" value="<?php echo esc_attr( $nav_menu_selected_title ); ?>" />
@@ -551,16 +537,10 @@
 									<label class="howto"><input type="checkbox"<?php checked( $auto_add ); ?> name="auto-add-pages" value="1" /> <?php printf( __('Automatically add new top-level pages' ), esc_url( admin_url( 'edit.php?post_type=page' ) ) ); ?></label>
 								</div>
 								<?php endif; ?>
-								<br class="clear" />
 								<div class="publishing-action">
 									<?php submit_button( empty( $nav_menu_selected_id ) ? __( 'Create Menu' ) : __( 'Save Menu' ), 'button-primary menu-save', 'save_menu', false, array( 'id' => 'save_menu_header' ) ); ?>
 								</div><!-- END .publishing-action -->
 
-								<?php if ( ! empty( $nav_menu_selected_id ) ) : ?>
-								<div class="delete-action">
-									<a class="submitdelete deletion menu-delete" href="<?php echo esc_url( wp_nonce_url( admin_url('nav-menus.php?action=delete&amp;menu=' . $nav_menu_selected_id), 'delete-nav_menu-' . $nav_menu_selected_id ) ); ?>"><?php _e('Delete Menu'); ?></a>
-								</div><!-- END .delete-action -->
-								<?php endif; ?>
 							</div><!-- END .major-publishing-actions -->
 						</div><!-- END #submitpost .submitbox -->
 						<?php
@@ -574,14 +554,20 @@
 					<div id="post-body">
 						<div id="post-body-content">
 							<?php
-							if ( isset( $edit_markup ) ) {
+							$drag_instructions = '';
+							if ( empty( $ordered_menu_items ) )
+								$drag_instructions = 'style="display: none;"';
+							
+							if ( isset( $edit_markup ) ) {								
+								echo '<div class="drag-instructions post-body-plain" ' . $drag_instructions . '>';
+								echo '<p>' . __('Drag each item into the order you prefer. Click an item to reveal additional configuration options.') . '</p>';
+								echo '</div>';
+								
 								if ( ! is_wp_error( $edit_markup ) )
 									echo $edit_markup;
 							} else if ( empty( $nav_menu_selected_id ) ) {
 								echo '<div class="post-body-plain">';
-								echo '<p>' . __('To create a custom menu, give it a name above and click Create Menu. Then choose items like pages, categories or custom links from the left column to add to this menu.') . '</p>';
-								echo '<p>' . __('After you have added your items, drag and drop to put them in the order you want. You can also click each item to reveal additional configuration options.') . '</p>';
-								echo '<p>' . __('When you have finished building your custom menu, make sure you click the Save Menu button.') . '</p>';
+								echo '<p>' . __('Give your custom menu a name above, then click Create Menu.') . '</p>';
 								echo '</div>';
 							}
 							?>
@@ -599,6 +585,7 @@
 					</div><!-- /#nav-menu-footer -->
 				</form><!-- /#update-nav-menu -->
 			</div><!-- /.menu-edit -->
+			<?php endif; ?>
 		</div><!-- /#menu-management -->
 	</div><!-- /#menu-management-liquid -->
 	</div><!-- /#nav-menus-frame -->
Index: wp-admin/css/wp-admin.css
===================================================================
--- wp-admin/css/wp-admin.css	(revision 23293)
+++ wp-admin/css/wp-admin.css	(working copy)
@@ -6750,8 +6750,17 @@
 
 /* nav-menu */
 
+.nav-menus-php #message {
+	display: none;
+}
+
+.nav-menus-php .nav-tab-wrapper {
+	margin-bottom: 20px;
+}
+
 #nav-menus-frame {
 	margin-left: 300px;
+	margin-top: 20px;
 }
 
 #wpbody-content #menu-settings-column {
@@ -6760,7 +6769,7 @@
 	margin-left: -300px;
 	clear: both;
 	float: left;
-	padding-top: 24px;
+	padding-top: 0;
 }
 
 .no-js #wpbody-content #menu-settings-column {
@@ -6785,10 +6794,26 @@
 	position: relative;
 }
 
+.blank-slate br { 
+	display: none; 
+} 
+
+.blank-slate .menu-name { 
+	height: 2em; 
+}
+
+.is-submenu {
+	color: #999;
+	font-style: italic;
+	font-weight: normal;
+	margin-left: 4px;
+}
+
 /* Menu Container */
 #menu-management-liquid {
 	float: left;
 	min-width: 100%;
+	margin-top: 3px;
 }
 
 #menu-management {
@@ -6835,55 +6860,6 @@
 	font-weight:bold;
 }
 
-/* Menu Tabs */
-
-#menu-management .nav-tabs-nav {
-	margin: 0 20px;
-}
-
-#menu-management .nav-tabs-arrow {
-	width: 10px;
-	padding: 0 5px 4px;
-	cursor: pointer;
-	position: absolute;
-	top: 0;
-	line-height: 22px;
-	font-size: 18px;
-	text-shadow: 0 1px 0 #fff;
-}
-
-#menu-management .nav-tabs-arrow-left {
-	left: 0;
-}
-
-#menu-management .nav-tabs-arrow-right {
-	right: 0;
-	text-align: right;
-}
-
-#menu-management .nav-tabs-wrapper {
-	width: 100%;
-	height: 28px;
-	margin-bottom: -1px;
-	overflow: hidden;
-}
-
-#menu-management .nav-tabs {
-	padding-left: 20px;
-	padding-right: 10px;
-}
-
-.js #menu-management .nav-tabs {
-	float: left;
-	margin-left: 0px;
-	margin-right: -400px;
-}
-
-#menu-management .nav-tab {
-	margin-bottom: 0;
-	font-size: 14px;
-}
-
 #select-nav-menu-container {
 	text-align: right;
 	padding: 0 10px 3px 10px;
@@ -6945,7 +6921,6 @@
 }
 
 .nav-menus-php .meta-sep,
-.nav-menus-php .submitdelete,
 .nav-menus-php .submitcancel {
 	display: block;
 	float: left;
@@ -7080,7 +7055,7 @@
 }
 
 #menu-to-edit {
-	padding: 1em 0;
+	padding: 0.1em 0;
 }
 
 .menu ul {
@@ -7326,6 +7301,11 @@
 	margin: 5px 0 1px;
 }
 
+.nav-menus-php .blank-slate .publishing-action { 
+	float: left; 
+	margin: 1px 0 0; 
+}
+
 .nav-menus-php .major-publishing-actions .delete-action {
 	vertical-align: middle;
 	text-align: left;