Index: wp-includes/post-template.php
===================================================================
--- wp-includes/post-template.php	(revision 23386)
+++ wp-includes/post-template.php	(working copy)
@@ -1301,7 +1301,7 @@
 		return false;
 
 	/* translators: revision date format, see http://php.net/date */
-	$datef = _x( 'j F, Y @ G:i', 'revision date format');
+	$datef = _x( 'D, M jS, Y @ G:i a', 'revision date format');
 	/* translators: 1: date */
 	$autosavef = __( '%1$s [Autosave]' );
 	/* translators: 1: date */
@@ -1371,13 +1371,14 @@
 	}
 
 	/* translators: post revision: 1: when, 2: author name */
-	$titlef = _x( '%1$s by %2$s', 'post revision' );
+	$titlef = _x( '<strong>%1$s</strong></td><td>%2$s', 'post revision' );
 
 	if ( $parent )
 		array_unshift( $revisions, $post );
 
 	$rows = $right_checked = '';
 	$class = false;
+	$i=0;
 	$can_edit_post = current_user_can( 'edit_post', $post->ID );
 	foreach ( $revisions as $revision ) {
 		if ( !current_user_can( 'read_post', $revision->ID ) )
@@ -1385,9 +1386,15 @@
 		if ( 'revision' === $type && wp_is_post_autosave( $revision ) )
 			continue;
 
-		$date = wp_post_revision_title( $revision );
+		$date = wp_post_revision_title( $revision, false );
 		$name = get_the_author_meta( 'display_name', $revision->post_author );
-
+		$editlink = '<a href="' . get_edit_post_link( $revision->ID ) . '">' . __( 'View' ) . '</a>';
+		if (1>$i++) {
+			$revision_comment_field = '<table><tr><td><textarea type="textarea" class="revsion-comment-imput" cols="50" rows="1" placeholder="' . __('Revision comments') . '" name="revision-comment-' . $revision->ID . '" ></textarea></td>';
+			$revision_comment_field.='<td><input type="button" value="Save" class="button saverevisioncomment"></td></tr></table>';
+		} else {
+			$revision_comment_field='<a href="javascript:;">' . __( 'Edit Comment' ) . '</a>';
+		}
 		if ( 'form-table' == $format ) {
 			if ( $left )
 				$left_checked = $left == $revision->ID ? ' checked="checked"' : '';
@@ -1398,20 +1405,23 @@
 			$class = $class ? '' : " class='alternate'";
 
 			if ( $post->ID != $revision->ID && $can_edit_post )
-				$actions = '<a href="' . wp_nonce_url( add_query_arg( array( 'revision' => $revision->ID, 'action' => 'restore' ) ), "restore-post_$post->ID|$revision->ID" ) . '">' . __( 'Restore' ) . '</a>';
+				$actions = 	'<a href="' . wp_nonce_url( add_query_arg( array( 'revision' => $revision->ID, 'action' => 'restore' ) ), "restore-post_$post->ID|$revision->ID" ) . '">' . __( 'Restore' ) . '</a>'.
+					' &middot ' . $editlink .
+					' &middot; <a href="' . 'revision.php?action=diff&right=' . $post->ID .'&left=' . $revision->ID . '">' . __( 'Compare to' ) . '</a>';
+				 
+
 			else
 				$actions = '';
 
+			$avatar	= get_avatar( $revision->post_author, 24 );
 			$rows .= "<tr$class>\n";
-			$rows .= "\t<th style='white-space: nowrap' scope='row'><input type='radio' name='left' value='$revision->ID'$left_checked /></th>\n";
-			$rows .= "\t<th style='white-space: nowrap' scope='row'><input type='radio' name='right' value='$revision->ID'$right_checked /></th>\n";
-			$rows .= "\t<td>$date</td>\n";
-			$rows .= "\t<td>$name</td>\n";
-			$rows .= "\t<td class='action-links'>$actions</td>\n";
+			$rows .= "\t<td class='revision-details'>$avatar <strong>$name</strong></td>\n";
+			$rows .= "\t<td class='revision-details'>$date<br />$actions</td>\n";
 			$rows .= "</tr>\n";
 		} else {
-			$title = sprintf( $titlef, $date, $name );
-			$rows .= "\t<li>$title</li>\n";
+			$avatar	= get_avatar( $revision->post_author, 18 );
+			$title = sprintf( $titlef, $name, $date );
+			$rows .= "\t<tr><td>$avatar $title</td><td>$revision_comment_field</td><td>$editlink</td></tr>\n";
 		}
 	}
 
@@ -1432,16 +1442,10 @@
 <table class="widefat post-revisions" cellspacing="0" id="post-revisions">
 	<col />
 	<col />
-	<col style="width: 33%" />
-	<col style="width: 33%" />
-	<col style="width: 33%" />
 <thead>
 <tr>
-	<th scope="col"><?php /* translators: column name in revisions */ _ex( 'Old', 'revisions column name' ); ?></th>
-	<th scope="col"><?php /* translators: column name in revisions */ _ex( 'New', 'revisions column name' ); ?></th>
-	<th scope="col"><?php /* translators: column name in revisions */ _ex( 'Date Created', 'revisions column name' ); ?></th>
-	<th scope="col"><?php _e( 'Author' ); ?></th>
-	<th scope="col" class="action-links"><?php _e( 'Actions' ); ?></th>
+	<th scope="col"><?php /* translators: column name in revisions */ _ex( 'Author', 'author column name' ); ?></th>
+	<th scope="col"><?php /* translators: column name in revisions */ _ex( 'Revisions', 'revisions column name' ); ?></th>
 </tr>
 </thead>
 <tbody>
@@ -1455,9 +1459,12 @@
 
 <?php
 	else :
-		echo "<ul class='post-revisions'>\n";
+		echo '<table id="post-revisions">';
+
+		echo '<tr class="post-revisions">';
+		echo '<td class="post-revision-header">' . __( 'Author' ) . '</td><td>'.__( 'Date/Time' ).'</td><td>' . __('Comment' ) .'</td><td>' . __('Action' ) . '</td></tr>';
 		echo $rows;
-		echo "</ul>";
+		echo "</table>";
 	endif;
 
 }
Index: wp-includes/wp-diff.php
===================================================================
--- wp-includes/wp-diff.php	(revision 23386)
+++ wp-includes/wp-diff.php	(working copy)
@@ -98,7 +98,7 @@
 	 * @return string
 	 */
 	function addedLine( $line ) {
-		return "<td>+</td><td class='diff-addedline'>{$line}</td>";
+		return "<td><div class='diff-addedline-leftcol'>{$line}</div></td><td class='ltype'><div class='diff-addedline'>" . __("Added") . "</div></td>";
 	}
 
 	/**
@@ -108,7 +108,7 @@
 	 * @return string
 	 */
 	function deletedLine( $line ) {
-		return "<td>-</td><td class='diff-deletedline'>{$line}</td>";
+		return "<td><div class='diff-deletedline-leftcol'>{$line}</div></td><td class='ltype'><div class='diff-deletedline'>" . __( "Removed" ) . "</div></td>";
 	}
 
 	/**
@@ -118,7 +118,7 @@
 	 * @return string
 	 */
 	function contextLine( $line ) {
-		return "<td> </td><td class='diff-context'>{$line}</td>";
+		return "<td><div class='diff-context'>{$line}</div></td>";
 	}
 
 	/**
@@ -127,7 +127,7 @@
 	 * @return string
 	 */
 	function emptyLine() {
-		return '<td colspan="2">&nbsp;</td>';
+		return '<td class="ltype">&nbsp;</td>';
 	}
 
 	/**
@@ -142,8 +142,8 @@
 		$r = '';
 		foreach ($lines as $line) {
 			if ( $encode )
-				$line = htmlspecialchars( $line );
-			$r .= '<tr>' . $this->emptyLine() . $this->addedLine( $line ) . "</tr>\n";
+				$line =  wp_kses_post( $line );
+			$r .= '<tr>' . $this->addedLine( $line ) . "</tr>\n";
 		}
 		return $r;
 	}
@@ -160,8 +160,8 @@
 		$r = '';
 		foreach ($lines as $line) {
 			if ( $encode )
-				$line = htmlspecialchars( $line );
-			$r .= '<tr>' . $this->deletedLine( $line ) . $this->emptyLine() . "</tr>\n";
+				$line = wp_kses_post( $line );
+			$r .= '<tr>' . $this->deletedLine( $line ) . "</tr>\n";
 		}
 		return $r;
 	}
@@ -178,9 +178,9 @@
 		$r = '';
 		foreach ($lines as $line) {
 			if ( $encode )
-				$line = htmlspecialchars( $line );
+				$line = wp_kses_post( $line );
 			$r .= '<tr>' .
-				$this->contextLine( $line ) . $this->contextLine( $line ) . "</tr>\n";
+				$this->contextLine( $line ) . $this->emptyLine() . "</tr>\n";
 		}
 		return $r;
 	}
@@ -248,14 +248,14 @@
 			if ( isset( $orig_diffs[$orig_rows[$row]] ) )
 				$orig_line = $orig_diffs[$orig_rows[$row]];
 			elseif ( isset( $orig[$orig_rows[$row]] ) )
-				$orig_line = htmlspecialchars($orig[$orig_rows[$row]]);
+				$orig_line = wp_kses_post($orig[$orig_rows[$row]]);
 			else
 				$orig_line = '';
 
 			if ( isset( $final_diffs[$final_rows[$row]] ) )
 				$final_line = $final_diffs[$final_rows[$row]];
 			elseif ( isset( $final[$final_rows[$row]] ) )
-				$final_line = htmlspecialchars($final[$final_rows[$row]]);
+				$final_line = wp_kses_post($final[$final_rows[$row]]);
 			else
 				$final_line = '';
 
@@ -264,7 +264,7 @@
 			} elseif ( $final_rows[$row] < 0 ) { // Final is blank. This is really a deleted row.
 				$r .= $this->_deleted( array($orig_line), false );
 			} else { // A true changed row.
-				$r .= '<tr>' . $this->deletedLine( $orig_line ) . $this->addedLine( $final_line ) . "</tr>\n";
+				$r .= '<tr>' . $this->deletedLine( $orig_line ) . '</tr><tr>' . $this->addedLine( $final_line ) . "</tr>\n";
 			}
 		}
 
Index: wp-includes/Text/Diff/Renderer/inline.php
===================================================================
--- wp-includes/Text/Diff/Renderer/inline.php	(revision 23386)
+++ wp-includes/Text/Diff/Renderer/inline.php	(working copy)
@@ -200,7 +200,7 @@
 
     function _encode(&$string)
     {
-        $string = htmlspecialchars($string);
+        $string = wp_kses_post($string);
     }
 
 }
Index: wp-includes/pluggable.php
===================================================================
--- wp-includes/pluggable.php	(revision 23386)
+++ wp-includes/pluggable.php	(working copy)
@@ -1722,16 +1722,16 @@
 		return '';
 
 	$r  = "<table class='diff'>\n";
-	$r .= "<col class='ltype' /><col class='content' /><col class='ltype' /><col class='content' />";
+	$r .= "<col class='content' /><col class='ltype' />";
 
 	if ( $args['title'] || $args['title_left'] || $args['title_right'] )
 		$r .= "<thead>";
 	if ( $args['title'] )
-		$r .= "<tr class='diff-title'><th colspan='4'>$args[title]</th></tr>\n";
+		$r .= "<tr class='diff-title'><th colspan='3'>$args[title]</th></tr>\n";
 	if ( $args['title_left'] || $args['title_right'] ) {
 		$r .= "<tr class='diff-sub-title'>\n";
-		$r .= "\t<td></td><th>$args[title_left]</th>\n";
-		$r .= "\t<td></td><th>$args[title_right]</th>\n";
+		$r .= "\t<th>$args[title_left]</th>\n";
+		$r .= "\t<th>$args[title_right]</th>\n";
 		$r .= "</tr>\n";
 	}
 	if ( $args['title'] || $args['title_left'] || $args['title_right'] )
Index: wp-admin/revision.php
===================================================================
--- wp-admin/revision.php	(revision 23386)
+++ wp-admin/revision.php	(working copy)
@@ -153,14 +153,20 @@
 
 <h2 class="long-header"><?php echo $h2; ?></h2>
 
-<table class="form-table ie-fixed">
+<table class="form-table ie-fixed revision-compare">
 	<col class="th" />
 <?php if ( 'diff' == $action ) : ?>
 <tr id="revision">
-	<th scope="row"></th>
 	<th scope="col" class="th-full">
-		<span class="alignleft"><?php printf( __('Older: %s'), wp_post_revision_title( $left_revision ) ); ?></span>
-		<span class="alignright"><?php printf( __('Newer: %s'), wp_post_revision_title( $right_revision ) ); ?></span>
+		<span  class="revision-details"><?php 
+		 _e('<strong>Comparing from the current version of the post.</strong><br />'); 
+	?>
+		<span class="revision-details" ><?php
+		printf( __('<strong>Comparing to revision dated </strong> %s, created by: '), wp_post_revision_title( $left_revision ) ); 
+		echo get_avatar( $left_revision->post_author, 18 ) . get_the_author_meta( 'display_name', $left_revision->post_author );
+	?>
+	</span> <br />
+		
 	</th>
 </tr>
 <?php endif;
@@ -175,13 +181,12 @@
 			continue; // There is no difference between left and right
 		$identical = false;
 	} else {
-		add_filter( "_wp_post_revision_field_$field", 'htmlspecialchars' );
+		add_filter( "_wp_post_revision_field_$field", 'wp_kses_post' );
 		$content = apply_filters( "_wp_post_revision_field_$field", $revision->$field, $field );
 	}
 	?>
 
 	<tr id="revision-field-<?php echo $field; ?>">
-		<th scope="row"><?php echo esc_html( $field_title ); ?></th>
 		<td><div class="pre"><?php echo $content; ?></div></td>
 	</tr>
 
@@ -203,8 +208,7 @@
 
 </table>
 
-<br class="clear" />
-
+<div id="revisions-detail-list">
 <h3><?php echo $title; ?></h3>
 
 <?php
@@ -216,8 +220,8 @@
 wp_list_post_revisions( $post, $args );
 
 ?>
-
 </div>
+</div>
 
 <?php
 require_once( './admin-footer.php' );
Index: wp-admin/css/colors-fresh.css
===================================================================
--- wp-admin/css/colors-fresh.css	(revision 23386)
+++ wp-admin/css/colors-fresh.css	(working copy)
@@ -1350,19 +1350,58 @@
 
 /* Diff */
 table.diff .diff-deletedline {
-	background-color: #fdd;
+	background-color: #c33;
+	padding:10px;
+	margin:2px;
+	-webkit-border-radius: 5px;
+	border-radius: 5px;
+	color: #fff;
+	text-align: center;
 }
+table.diff .diff-deletedline-leftcol {
+	border: #c33 dotted 2px;
+	padding:10px;
+	margin:2px;
+	-webkit-border-radius: 5px;
+	border-radius: 5px;
+	text-decoration: line-through;
+}
 
+table.diff .diff-context {
+	padding:10px;
+	margin:2px;
+	-webkit-border-radius: 5px;
+	border-radius: 5px;
+}
+
+table.diff .diff-context:hover {
+	background-color: #FFE;
+}
+
 table.diff .diff-deletedline del {
-	background-color: #f99;
+	background-color: #f33;
 }
 
 table.diff .diff-addedline {
-	background-color: #dfd;
+	background-color: #3a3;
+	padding:10px;
+	margin:2px;
+	-webkit-border-radius: 5px;
+	border-radius: 5px;
+	color: #fff;
+	text-align: center;
 }
 
+table.diff .diff-addedline-leftcol {
+	border: #3a3 dotted 2px;
+	padding:10px;
+	margin:2px;
+	-webkit-border-radius: 5px;
+	border-radius: 5px;
+}
+
 table.diff .diff-addedline ins {
-	background-color: #9f9;
+	background-color: #3f3;
 }
 
 #att-info {
Index: wp-admin/css/wp-admin.css
===================================================================
--- wp-admin/css/wp-admin.css	(revision 23386)
+++ wp-admin/css/wp-admin.css	(working copy)
@@ -3436,7 +3436,7 @@
 }
 
 table.diff col.content {
-	width: 50%;
+	width: auto;
 }
 
 table.diff tr {
@@ -8585,3 +8585,61 @@
 .locale-lt-lt .inline-edit-row fieldset label span.input-text-wrap {
 	margin-left: 8em;
 }
+ul.post-revisions img {
+	float: left;
+	margin: 2px;
+}
+ul.post-revisions li {
+	border-bottom: 1px solid #FFF;
+}
+ul.post-revisions li  a {
+	line-height: 24px;
+}
+table#post-revisions tr td.revision-details, span.revision-details {
+	line-height: 16px;
+	padding: 0;
+	height: 30px;
+	vertical-align: middle;;
+}
+.form-table #revision  th{
+	padding-left: 28px;
+}
+table#post-revisions tr td img {
+	float: left;
+	margin: 4px;
+}
+ span.revision-details img {
+ 	margin: 1px;
+ 	vertical-align: middle;
+ }
+.diff .ltype {
+	width: 100px;
+}
+tr#revision-field-post_title td div {
+	font-size: 150%;
+	font-weight: bold;
+}
+.revsion-comment-imput {
+	min-width: 300px;
+	height: 24px;
+}
+tr.post-revisions td, table#post-revisions tbody tr td
+{
+	padding: 5px;
+}
+table#post-revisions tbody tr td table tr td {
+	padding: 0;
+}
+tr.post-revisions {
+	font-weight: bold;
+}
+@media screen and (min-width: 1200px) {
+	.revision-compare {
+		float: right;
+		width: 70%;
+	}
+	#revisions-detail-list {
+		float: left;
+		width: 30%;
+	}
+}
\ No newline at end of file