Index: wp-signup.php
===================================================================
--- wp-signup.php	(revision 25478)
+++ wp-signup.php	(working copy)
@@ -18,6 +18,11 @@
  * @since MU
  */
 function do_signup_header() {
+	/**
+	 * Fires within the <head></head> section of the sign up screen.
+	 *
+	 * @since 3.0
+	 */
 	do_action( 'signup_header' );
 }
 add_action( 'wp_head', 'do_signup_header' );
@@ -63,6 +68,11 @@
 add_action( 'wp_head', 'wpmu_signup_stylesheet' );
 get_header();
 
+/**
+ * Fires actions before sign up form on the sign up screen.
+ *
+ * @since 3.0
+ */
 do_action( 'before_signup_form' );
 ?>
 <div id="content" class="widecolumn">
@@ -79,7 +89,7 @@
  */
 function show_blog_form($blogname = '', $blog_title = '', $errors = '') {
 	global $current_site;
-	// Blog name
+	// Blog nam e
 	if ( !is_subdomain_install() )
 		echo '<label for="blogname">' . __('Site Name:') . '</label>';
 	else
@@ -128,6 +138,11 @@
 	</div>
 
 	<?php
+    /**
+     * Fires actions after sign up blog form.
+     *
+     * @since 3.0
+     */
 	do_action('signup_blogform', $errors);
 }
 
@@ -176,6 +191,11 @@
 	if ( $errmsg = $errors->get_error_message('generic') ) {
 		echo '<p class="error">' . $errmsg . '</p>';
 	}
+    /**
+     * Add extra fields to the user registration form.
+     *
+     * @since 3.0
+     */
 	do_action( 'signup_extra_fields', $errors );
 }
 
@@ -209,7 +229,12 @@
 		$errors = new WP_Error();
 	}
 
-	// allow definition of default variables
+    /**
+     * allow definition of default variables.
+     *
+     * @since 3.0
+     * @param array $blogname, $blog_title, $errors
+     */
 	$filtered_results = apply_filters('signup_another_blog_init', array('blogname' => $blogname, 'blog_title' => $blog_title, 'errors' => $errors ));
 	$blogname = $filtered_results['blogname'];
 	$blog_title = $filtered_results['blog_title'];
@@ -239,6 +264,11 @@
 	<p><?php _e( 'If you&#8217;re not going to use a great site domain, leave it for a new user. Now have at it!' ) ?></p>
 	<form id="setupform" method="post" action="wp-signup.php">
 		<input type="hidden" name="stage" value="gimmeanotherblog" />
+        /**
+         * Add extra hidden fields to the form of sign up another blog.
+         *
+         * @since 3.0
+         */
 		<?php do_action( 'signup_hidden_fields' ); ?>
 		<?php show_blog_form($blogname, $blog_title, $errors); ?>
 		<p class="submit"><input type="submit" name="submit" class="submit" value="<?php esc_attr_e( 'Create Site' ) ?>" /></p>
@@ -271,7 +301,19 @@
 	}
 
 	$public = (int) $_POST['blog_public'];
+    /**
+     * Filter for the new blog meta.
+     *
+     * @since 3.0
+     * @param array $blogname, $blog_title, $errors
+     */
 	$meta = apply_filters( 'signup_create_blog_meta', array( 'lang_id' => 1, 'public' => $public ) ); // deprecated
+    /**
+     * Filter for the new blog meta after the signup_create_blog_meta hook.
+     *
+     * @since 3.0
+     * @param array $meta
+     */
 	$meta = apply_filters( 'add_signup_meta', $meta );
 
 	wpmu_create_blog( $domain, $path, $blog_title, $current_user->ID, $meta, $wpdb->siteid );
@@ -297,6 +339,11 @@
 		<?php printf( __( '<a href="http://%1$s">http://%2$s</a> is your new site. <a href="%3$s">Log in</a> as &#8220;%4$s&#8221; using your existing password.' ), $domain.$path, $domain.$path, "http://" . $domain.$path . "wp-login.php", $user_name ) ?>
 	</p>
 	<?php
+    /**
+     * Fires actions when sign up finished.
+     *
+     * @since 3.0
+     */
 	do_action( 'signup_finished' );
 }
 
@@ -319,7 +366,12 @@
 
 	$signup_for = isset( $_POST[ 'signup_for' ] ) ? esc_html( $_POST[ 'signup_for' ] ) : 'blog';
 
-	// allow definition of default variables
+    /**
+	 * allow definition of default variables for sign up user
+     *
+     * @since 3.0
+     * @param array $user_name, $user_email, $errors
+     */
 	$filtered_results = apply_filters('signup_user_init', array('user_name' => $user_name, 'user_email' => $user_email, 'errors' => $errors ));
 	$user_name = $filtered_results['user_name'];
 	$user_email = $filtered_results['user_email'];
@@ -330,6 +382,11 @@
 	<h2><?php printf( __( 'Get your own %s account in seconds' ), $current_site->site_name ) ?></h2>
 	<form id="setupform" method="post" action="wp-signup.php">
 		<input type="hidden" name="stage" value="validate-user-signup" />
+        /**
+         * Add extra hidden fields to the form of sign up another blog.
+         *
+         * @since 3.0
+         */
 		<?php do_action( 'signup_hidden_fields' ); ?>
 		<?php show_user_form($user_name, $user_email, $errors); ?>
 
@@ -376,6 +433,12 @@
 		return false;
 	}
 
+    /**
+	 * Allow definition of default for the meta variables for sign up user
+     *
+     * @since 3.0
+     * @param array $user_name, $user_email, $errors
+     */
 	wpmu_signup_user($user_name, $user_email, apply_filters( 'add_signup_meta', array() ) );
 
 	confirm_user_signup($user_name, $user_email);
@@ -397,6 +460,11 @@
 	<p><?php printf( __( 'Check your inbox at <strong>%s</strong> and click the link given.' ), $user_email ); ?></p>
 	<p><?php _e( 'If you do not activate your username within two days, you will have to sign up again.' ); ?></p>
 	<?php
+    /**
+     * Fires actions when sign up finished.
+     *
+     * @since 3.0
+     */
 	do_action( 'signup_finished' );
 }
 
@@ -417,7 +485,12 @@
 	if ( !is_wp_error($errors) )
 		$errors = new WP_Error();
 
-	// allow definition of default variables
+    /**
+	 * Allow definition of default variablesi for the sign upped blog
+     *
+     * @since 3.0
+     * @param array $user_name, $user_email, $blogname, $blog_title, $errors
+     */
 	$filtered_results = apply_filters('signup_blog_init', array('user_name' => $user_name, 'user_email' => $user_email, 'blogname' => $blogname, 'blog_title' => $blog_title, 'errors' => $errors ));
 	$user_name = $filtered_results['user_name'];
 	$user_email = $filtered_results['user_email'];
@@ -432,6 +505,11 @@
 		<input type="hidden" name="stage" value="validate-blog-signup" />
 		<input type="hidden" name="user_name" value="<?php echo esc_attr($user_name) ?>" />
 		<input type="hidden" name="user_email" value="<?php echo esc_attr($user_email) ?>" />
+        /**
+         * Add extra hidden fields to the form of sign up another blog.
+         *
+         * @since 3.0
+         */
 		<?php do_action( 'signup_hidden_fields' ); ?>
 		<?php show_blog_form($blogname, $blog_title, $errors); ?>
 		<p class="submit"><input type="submit" name="submit" class="submit" value="<?php esc_attr_e('Signup') ?>" /></p>
@@ -471,6 +549,12 @@
 
 	$public = (int) $_POST['blog_public'];
 	$meta = array ('lang_id' => 1, 'public' => $public);
+    /**
+	 * Allow definition of default variablesi for the sign upped blog
+     *
+     * @since 3.0
+     * @param array $user_name, $user_email, $blogname, $blog_title, $errors
+     */
 	$meta = apply_filters( 'add_signup_meta', $meta );
 
 	wpmu_signup_blog($domain, $path, $blog_title, $user_name, $user_email, $meta);
@@ -507,11 +591,22 @@
 		</ul>
 	</p>
 	<?php
+    /**
+     * Fires actions when sign up finished.
+     *
+     * @since 3.0
+     */
 	do_action( 'signup_finished' );
 }
 
 // Main
 $active_signup = get_site_option( 'registration', 'none' );
+/**
+ * Filter for sign up type. It should return "all", "none", "blog" or "user".
+ *
+ * @since 3.0
+ * @param string $active_signup
+ */
 $active_signup = apply_filters( 'wpmu_active_signup', $active_signup ); // return "all", "none", "blog" or "user"
 
 // Make the signup type translatable.
@@ -552,6 +647,11 @@
 		case 'default':
 		default :
 			$user_email = isset( $_POST[ 'user_email' ] ) ? $_POST[ 'user_email' ] : '';
+            /**
+             * Fires actions when sign up form sent.
+             *
+             * @since 3.0
+             */
 			do_action( 'preprocess_signup_form' ); // populate the form from invites, elsewhere?
 			if ( is_user_logged_in() && ( $active_signup == 'all' || $active_signup == 'blog' ) )
 				signup_another_blog($newblogname);
@@ -576,6 +676,11 @@
 ?>
 </div>
 </div>
+/**
+ * Fires actions after sign up form before wp_footer action.
+ *
+ * @since 3.0
+ */
 <?php do_action( 'after_signup_form' ); ?>
 
 <?php get_footer(); ?>